import { NG_VALUE_ACCESSOR } from '@angular/forms';
import CodeFlask from 'codeflask';
import { Injectable, NgModule, Component, forwardRef, ViewChild, Output, EventEmitter, Input, defineInjectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgCodeflaskService {
    constructor() { }
}
NgCodeflaskService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgCodeflaskService.ctorParameters = () => [];
/** @nocollapse */ NgCodeflaskService.ngInjectableDef = defineInjectable({ factory: function NgCodeflaskService_Factory() { return new NgCodeflaskService(); }, token: NgCodeflaskService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgCodeflaskComponent {
    constructor() {
        this.isReadOnly = false;
        this.isRTL = false;
        this.hasLineNumber = true;
        this.useDefaultTheme = true;
        this.currentLanguage = "html";
        this.currentCode = null;
        this.afterInit = false;
        this.options = {
            defaultTheme: this.useDefaultTheme,
            language: this.currentLanguage,
            lineNumbers: this.hasLineNumber,
            readonly: this.isReadOnly,
            rtl: this.isRTL
        };
        this.propagateChange = (/**
         * @param {?} _
         * @return {?}
         */
        (_) => { });
        this.codeChange = new EventEmitter();
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    writeValue(obj) {
        this.code = obj;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.propagateChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.propagateChange(this.code);
    }
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    setDisabledState(isDisabled) {
        this.readonly = isDisabled;
    }
    /**
     * @return {?}
     */
    emitChanges() {
        this.propagateChange(this.code);
    }
    /**
     * @return {?}
     */
    get code() {
        return this.onGetCode();
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set code(val) {
        this.currentCode = val;
        this.onCodeUpdate(this.currentCode);
        this.codeChange.emit(this.currentCode);
        this.propagateChange(this.currentCode);
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set readonly(val) {
        this.isReadOnly = val;
        if (this.afterInit === true) {
            if (this.isReadOnly === true) {
                this.onDisableReadonly();
            }
            else {
                this.onEnableReadonly();
            }
        }
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set rtl(val) {
        this.isRTL = val;
        if (this.afterInit === true) {
            this.onBuildEditor();
        }
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set linenumbers(val) {
        this.hasLineNumber = val;
        if (this.afterInit === true) {
            this.onBuildEditor();
        }
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set defaultTheme(val) {
        this.useDefaultTheme = val;
        if (this.afterInit === true) {
            this.onBuildEditor();
        }
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set language(val) {
        this.currentLanguage = val;
        if (this.afterInit === true) {
            this.onUpdateLanguage(this.currentLanguage);
        }
    }
    /**
     * @param {?} prismLanguage
     * @return {?}
     */
    set addLanguage(prismLanguage) {
        this.onAddLanguage(prismLanguage);
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.onBuildEditor();
        this.afterInit = true;
    }
    /**
     * @private
     * @return {?}
     */
    onBuildEditor() {
        /** @type {?} */
        const myDiv = this.editorContent.nativeElement;
        this.flaskInstance = new CodeFlask(myDiv, this.options);
        if (this.currentCode != null) {
            this.onCodeUpdate(this.currentCode);
        }
        this.flaskInstance.onUpdate((/**
         * @param {?} code
         * @return {?}
         */
        (code) => {
            this.currentCode = code;
            this.codeChange.emit(this.currentCode);
            this.propagateChange(this.currentCode);
        }));
    }
    /**
     * @private
     * @param {?} val
     * @return {?}
     */
    onCodeUpdate(val) {
        if (this.flaskInstance != null) {
            this.flaskInstance.updateCode(val);
        }
    }
    /**
     * @private
     * @return {?}
     */
    onGetCode() {
        if (this.flaskInstance != null) {
            return this.flaskInstance.getCode();
        }
    }
    /**
     * @private
     * @param {?} lang
     * @return {?}
     */
    onUpdateLanguage(lang) {
        if (this.flaskInstance != null) {
            this.flaskInstance.updateLanguage(lang);
        }
    }
    /**
     * @private
     * @param {?} prismLanguage
     * @return {?}
     */
    onAddLanguage(prismLanguage) {
        if (this.flaskInstance != null) {
            this.flaskInstance.addLanguage(prismLanguage.lang, prismLanguage.options);
        }
    }
    /**
     * @private
     * @return {?}
     */
    onDisableReadonly() {
        if (this.flaskInstance != null) {
            this.flaskInstance.disableReadonlyMode();
        }
    }
    /**
     * @private
     * @return {?}
     */
    onEnableReadonly() {
        if (this.flaskInstance != null) {
            this.flaskInstance.enableReadonlyMode();
        }
    }
}
NgCodeflaskComponent.decorators = [
    { type: Component, args: [{
                selector: 'ng-codeflask',
                template: "<div>\r\n  <div #editor class=\"codeflask-editor\">\r\n</div>",
                providers: [
                    { provide: NG_VALUE_ACCESSOR, useExisting: forwardRef((/**
                         * @return {?}
                         */
                        () => NgCodeflaskComponent)), multi: true }
                ],
                styles: [""]
            }] }
];
NgCodeflaskComponent.propDecorators = {
    editorContent: [{ type: ViewChild, args: ["editor",] }],
    codeChange: [{ type: Output }],
    code: [{ type: Input }],
    readonly: [{ type: Input }],
    rtl: [{ type: Input }],
    linenumbers: [{ type: Input }],
    defaultTheme: [{ type: Input }],
    language: [{ type: Input }],
    addLanguage: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgCodeflaskModule {
}
NgCodeflaskModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgCodeflaskComponent],
                imports: [],
                exports: [NgCodeflaskComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Options {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgCodeflaskService, NgCodeflaskComponent, NgCodeflaskModule, Options };

//# sourceMappingURL=ng-codeflask.js.map