import { NG_VALUE_ACCESSOR } from '@angular/forms';
import CodeFlask from 'codeflask';
import { Injectable, NgModule, Component, forwardRef, ViewChild, Output, EventEmitter, Input, defineInjectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgCodeflaskService = /** @class */ (function () {
    function NgCodeflaskService() {
    }
    NgCodeflaskService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgCodeflaskService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgCodeflaskService.ngInjectableDef = defineInjectable({ factory: function NgCodeflaskService_Factory() { return new NgCodeflaskService(); }, token: NgCodeflaskService, providedIn: "root" });
    return NgCodeflaskService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgCodeflaskComponent = /** @class */ (function () {
    function NgCodeflaskComponent() {
        this.isReadOnly = false;
        this.isRTL = false;
        this.hasLineNumber = true;
        this.useDefaultTheme = true;
        this.currentLanguage = "html";
        this.currentCode = null;
        this.afterInit = false;
        this.options = {
            defaultTheme: this.useDefaultTheme,
            language: this.currentLanguage,
            lineNumbers: this.hasLineNumber,
            readonly: this.isReadOnly,
            rtl: this.isRTL
        };
        this.propagateChange = (/**
         * @param {?} _
         * @return {?}
         */
        function (_) { });
        this.codeChange = new EventEmitter();
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    NgCodeflaskComponent.prototype.writeValue = /**
     * @param {?} obj
     * @return {?}
     */
    function (obj) {
        this.code = obj;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NgCodeflaskComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NgCodeflaskComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange(this.code);
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    NgCodeflaskComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.readonly = isDisabled;
    };
    /**
     * @return {?}
     */
    NgCodeflaskComponent.prototype.emitChanges = /**
     * @return {?}
     */
    function () {
        this.propagateChange(this.code);
    };
    Object.defineProperty(NgCodeflaskComponent.prototype, "code", {
        get: /**
         * @return {?}
         */
        function () {
            return this.onGetCode();
        },
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.currentCode = val;
            this.onCodeUpdate(this.currentCode);
            this.codeChange.emit(this.currentCode);
            this.propagateChange(this.currentCode);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgCodeflaskComponent.prototype, "readonly", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.isReadOnly = val;
            if (this.afterInit === true) {
                if (this.isReadOnly === true) {
                    this.onDisableReadonly();
                }
                else {
                    this.onEnableReadonly();
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgCodeflaskComponent.prototype, "rtl", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.isRTL = val;
            if (this.afterInit === true) {
                this.onBuildEditor();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgCodeflaskComponent.prototype, "linenumbers", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.hasLineNumber = val;
            if (this.afterInit === true) {
                this.onBuildEditor();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgCodeflaskComponent.prototype, "defaultTheme", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.useDefaultTheme = val;
            if (this.afterInit === true) {
                this.onBuildEditor();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgCodeflaskComponent.prototype, "language", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.currentLanguage = val;
            if (this.afterInit === true) {
                this.onUpdateLanguage(this.currentLanguage);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgCodeflaskComponent.prototype, "addLanguage", {
        set: /**
         * @param {?} prismLanguage
         * @return {?}
         */
        function (prismLanguage) {
            this.onAddLanguage(prismLanguage);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NgCodeflaskComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.onBuildEditor();
        this.afterInit = true;
    };
    /**
     * @private
     * @return {?}
     */
    NgCodeflaskComponent.prototype.onBuildEditor = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var myDiv = this.editorContent.nativeElement;
        this.flaskInstance = new CodeFlask(myDiv, this.options);
        if (this.currentCode != null) {
            this.onCodeUpdate(this.currentCode);
        }
        this.flaskInstance.onUpdate((/**
         * @param {?} code
         * @return {?}
         */
        function (code) {
            _this.currentCode = code;
            _this.codeChange.emit(_this.currentCode);
            _this.propagateChange(_this.currentCode);
        }));
    };
    /**
     * @private
     * @param {?} val
     * @return {?}
     */
    NgCodeflaskComponent.prototype.onCodeUpdate = /**
     * @private
     * @param {?} val
     * @return {?}
     */
    function (val) {
        if (this.flaskInstance != null) {
            this.flaskInstance.updateCode(val);
        }
    };
    /**
     * @private
     * @return {?}
     */
    NgCodeflaskComponent.prototype.onGetCode = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.flaskInstance != null) {
            return this.flaskInstance.getCode();
        }
    };
    /**
     * @private
     * @param {?} lang
     * @return {?}
     */
    NgCodeflaskComponent.prototype.onUpdateLanguage = /**
     * @private
     * @param {?} lang
     * @return {?}
     */
    function (lang) {
        if (this.flaskInstance != null) {
            this.flaskInstance.updateLanguage(lang);
        }
    };
    /**
     * @private
     * @param {?} prismLanguage
     * @return {?}
     */
    NgCodeflaskComponent.prototype.onAddLanguage = /**
     * @private
     * @param {?} prismLanguage
     * @return {?}
     */
    function (prismLanguage) {
        if (this.flaskInstance != null) {
            this.flaskInstance.addLanguage(prismLanguage.lang, prismLanguage.options);
        }
    };
    /**
     * @private
     * @return {?}
     */
    NgCodeflaskComponent.prototype.onDisableReadonly = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.flaskInstance != null) {
            this.flaskInstance.disableReadonlyMode();
        }
    };
    /**
     * @private
     * @return {?}
     */
    NgCodeflaskComponent.prototype.onEnableReadonly = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.flaskInstance != null) {
            this.flaskInstance.enableReadonlyMode();
        }
    };
    NgCodeflaskComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ng-codeflask',
                    template: "<div>\r\n  <div #editor class=\"codeflask-editor\">\r\n</div>",
                    providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return NgCodeflaskComponent; })), multi: true }
                    ],
                    styles: [""]
                }] }
    ];
    NgCodeflaskComponent.propDecorators = {
        editorContent: [{ type: ViewChild, args: ["editor",] }],
        codeChange: [{ type: Output }],
        code: [{ type: Input }],
        readonly: [{ type: Input }],
        rtl: [{ type: Input }],
        linenumbers: [{ type: Input }],
        defaultTheme: [{ type: Input }],
        language: [{ type: Input }],
        addLanguage: [{ type: Input }]
    };
    return NgCodeflaskComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgCodeflaskModule = /** @class */ (function () {
    function NgCodeflaskModule() {
    }
    NgCodeflaskModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgCodeflaskComponent],
                    imports: [],
                    exports: [NgCodeflaskComponent]
                },] }
    ];
    return NgCodeflaskModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Options = /** @class */ (function () {
    function Options() {
    }
    return Options;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgCodeflaskService, NgCodeflaskComponent, NgCodeflaskModule, Options };

//# sourceMappingURL=ng-codeflask.js.map